extern "C" {
#include "gis.h"
#include "includes.h"

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
}

#include <iostream>
#include <qpixmap.h>
#include <qimage.h>
#include "local_cpp.h"

/* create file name for location file */
char *getFileName(char *name)
{
	char *s ;

	s = (char *)malloc(strlen(name)+4) ;
	if ( s != NULL ) {
		strcat(strcpy(s, name), ".loc") ;
	}

	return s ;
}

int Panel_save(char *name, int top, int bottom, int left, int right)
{
	/* create an image of the area to be saved from the backing store */
	QPixmap *buffer = window->getBuffer() ;
	QImage fullImage = buffer->convertToImage() ;
	QImage partImage = fullImage.copy(left, top, right-left+1, bottom-top+1) ;

	if ( !partImage.save(name, "PPM") ) {
		fprintf(stderr, "unable to save to file\n") ;
		return -1 ;
	}

	/* also save a separate file with the location of the saved area */
	FILE *fd ;
	char *s = getFileName(name) ;
	bool flag = FALSE ;

	if ( s != NULL ) {
		if ( (fd=fopen(s, "w")) != NULL ) {
			fprintf(fd, "%d %d\n", left, top) ;
			fclose(fd) ;
			flag = TRUE ;
		}
		free(s) ;
	}

	if ( !flag ) {
		fprintf(stderr, "failed to save location\n") ;
		return -1 ;
	}

    return 0;
}

int Panel_restore(char *name)
{
	QImage image ;

	if ( !image.load(name, "PPM") ) {
		fprintf(stderr, "failed to load image\n") ;
		return -1 ;
	}

	FILE *fd ;
	char *s = getFileName(name) ;
	bool flag = FALSE ;
	int left, top ;

	if ( s != NULL ) {
		if ( (fd=fopen(s, "r")) != NULL ) {
			if ( fscanf(fd, "%d %d", &left, &top) == 2 ) {
				flag = TRUE ;
			}
			fclose(fd) ;
		}
		free(s) ;
	}

	if ( !flag ) {
		fprintf(stderr, "failed to read location\n") ;
		return -1 ;
	}

	QPixmap pixmap ;
	pixmap.convertFromImage(image, 0) ;
	bitBlt(window, left, top, &pixmap) ;
	bitBlt(window->getBuffer(), left, top, &pixmap) ;

    return 0;
}

int Panel_delete(char *name)
{
    unlink(name);

	char *s = getFileName(name) ;

	if ( s != NULL ) {
		unlink(s) ;
		free(s) ;
	}
    return 0;
}

