extern "C" {
#include "includes.h"
#include "driver.h"
}

#include <qpainter.h>
#include <qpoint.h>
#include <qcolor.h>
#include "local_cpp.h"

static void DrawPolygon(QPointArray &a)
{
	QColor color(current_color) ;

	QPainter *bp = window->getBufferPainter() ;
	QPainter *wp = window->getWindowPainter() ;

	bp->setPen(color) ;
	wp->setPen(color) ;

	bp->drawPolygon(a) ;
	wp->drawPolygon(a) ;
}

/* A polygon is drawn using the current color.  It has "number"
 * verticies which are found in the absolute coordinate pairs
 * represented in the "xarray" and "yarray" arrays.  NOTE: Cursor
 * location is NOT updated in Polygon_rel(). */

int Polygon_abs (int *xarray, int *yarray, int number)
{
	QPointArray a(number) ;

	for ( int i=0; i<number; ++i ) {
		a.setPoint(i, xarray[i], yarray[i]) ;
	}

	DrawPolygon(a) ;

	return 1 ;
}

int Polygon_rel (int *xarray, int *yarray, int number)
{
	QPointArray a(number) ;

	for ( int i=0; i<number; ++i ) {
		a.setPoint(i, xarray[i]+cur_x, yarray[i]+cur_y) ;
	}

	DrawPolygon(a) ;

	return 1 ;
}
