#ifndef DRIVERWINDOW_H
#define DRIVERWINDOW_H

#include <qpainter.h>
#include <qpixmap.h>
#include <qevent.h>
#include <qwidget.h>
#include <qpen.h>
#include <qcolor.h>


class DriverWindow : public QWidget
{
public:
	enum DrawFunction { None, Rectangle, Line } ;
	DriverWindow() ;
	QPainter *getBufferPainter() ;
	QPainter *getWindowPainter() ;
	QPixmap *getBuffer() ;
	QMouseEvent *getButtonPress(enum DrawFunction, int, int) ;

protected:
	virtual void paintEvent(QPaintEvent*) ;
	virtual void resizeEvent(QResizeEvent*) ;
	virtual void mousePressEvent(QMouseEvent *) ;
	virtual void mouseMoveEvent(QMouseEvent *) ;

private:
	void drawRubberBand(QMouseEvent *, bool) ;
	static void drawRect(int, int, int, int, QPainter*) ;
	static void drawLine(int, int, int, int, QPainter*) ;
	QPixmap buffer ;
	QPainter *bufferPainter ;
	QPainter *windowPainter ;
	int initialised ;
	QMouseEvent *buttonPress ;
	int lastx, lasty ;
	int origx, origy ;
	bool drawn ;
	enum DrawFunction drawFunction ;
};

#endif
